---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Converter board registers
---------------------------------------------------------------------------------------
-- File           : C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs.vhd
-- Author         : auto-generated by wbgen2 from C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs.wb
-- Created        : 12/16/16 14:31:04
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE C:\Users\debouhir\work\CONV-TTL-BLO\conv-ttl-blo\conv-ttl-blo-gw\ip_cores\conv-common-gw\modules\conv_regs.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.reg_wbgen2_pkg.all;


entity conv_regs is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(5 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    regs_i                                   : in     t_reg_in_registers;
    regs_o                                   : out    t_reg_out_registers
  );
end conv_regs;

architecture syn of conv_regs is

signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(5 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      regs_o.sr_i2c_wdto_load_o <= '0';
      regs_o.sr_i2c_err_load_o <= '0';
      regs_o.sr_pmisse_load_o <= '0';
      regs_o.cr_rst_unlock_load_o <= '0';
      regs_o.cr_rst_load_o <= '0';
      regs_o.cr_mpt_wr_o <= '0';
      regs_o.ch1ttlpcr_load_o <= '0';
      regs_o.ch2ttlpcr_load_o <= '0';
      regs_o.ch3ttlpcr_load_o <= '0';
      regs_o.ch4ttlpcr_load_o <= '0';
      regs_o.ch5ttlpcr_load_o <= '0';
      regs_o.ch6ttlpcr_load_o <= '0';
      regs_o.ch1blopcr_load_o <= '0';
      regs_o.ch2blopcr_load_o <= '0';
      regs_o.ch3blopcr_load_o <= '0';
      regs_o.ch4blopcr_load_o <= '0';
      regs_o.ch5blopcr_load_o <= '0';
      regs_o.ch6blopcr_load_o <= '0';
      regs_o.tvlr_load_o <= '0';
      regs_o.tvhr_load_o <= '0';
      regs_o.tbcsr_clr_load_o <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          regs_o.sr_i2c_wdto_load_o <= '0';
          regs_o.sr_i2c_err_load_o <= '0';
          regs_o.sr_pmisse_load_o <= '0';
          regs_o.cr_rst_unlock_load_o <= '0';
          regs_o.cr_rst_load_o <= '0';
          regs_o.cr_mpt_wr_o <= '0';
          regs_o.ch1ttlpcr_load_o <= '0';
          regs_o.ch2ttlpcr_load_o <= '0';
          regs_o.ch3ttlpcr_load_o <= '0';
          regs_o.ch4ttlpcr_load_o <= '0';
          regs_o.ch5ttlpcr_load_o <= '0';
          regs_o.ch6ttlpcr_load_o <= '0';
          regs_o.ch1blopcr_load_o <= '0';
          regs_o.ch2blopcr_load_o <= '0';
          regs_o.ch3blopcr_load_o <= '0';
          regs_o.ch4blopcr_load_o <= '0';
          regs_o.ch5blopcr_load_o <= '0';
          regs_o.ch6blopcr_load_o <= '0';
          regs_o.tvlr_load_o <= '0';
          regs_o.tvhr_load_o <= '0';
          regs_o.tbcsr_clr_load_o <= '0';
          ack_in_progress <= '0';
        else
          regs_o.sr_i2c_wdto_load_o <= '0';
          regs_o.sr_i2c_err_load_o <= '0';
          regs_o.sr_pmisse_load_o <= '0';
          regs_o.cr_rst_unlock_load_o <= '0';
          regs_o.cr_rst_load_o <= '0';
          regs_o.cr_mpt_wr_o <= '0';
          regs_o.ch1ttlpcr_load_o <= '0';
          regs_o.ch2ttlpcr_load_o <= '0';
          regs_o.ch3ttlpcr_load_o <= '0';
          regs_o.ch4ttlpcr_load_o <= '0';
          regs_o.ch5ttlpcr_load_o <= '0';
          regs_o.ch6ttlpcr_load_o <= '0';
          regs_o.ch1blopcr_load_o <= '0';
          regs_o.ch2blopcr_load_o <= '0';
          regs_o.ch3blopcr_load_o <= '0';
          regs_o.ch4blopcr_load_o <= '0';
          regs_o.ch5blopcr_load_o <= '0';
          regs_o.ch6blopcr_load_o <= '0';
          regs_o.tvlr_load_o <= '0';
          regs_o.tvhr_load_o <= '0';
          regs_o.tbcsr_clr_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(5 downto 0) is
          when "000000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.bidr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000001" => 
            if (wb_we_i = '1') then
              regs_o.sr_i2c_wdto_load_o <= '1';
              regs_o.sr_i2c_err_load_o <= '1';
              regs_o.sr_pmisse_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= regs_i.sr_gwvers_i;
            rddata_reg(15 downto 8) <= regs_i.sr_switches_i;
            rddata_reg(21 downto 16) <= regs_i.sr_rtm_i;
            rddata_reg(22) <= regs_i.sr_i2c_wdto_i;
            rddata_reg(23) <= regs_i.sr_wrpres_i;
            rddata_reg(24) <= regs_i.sr_i2c_err_i;
            rddata_reg(30 downto 25) <= regs_i.sr_pmisse_i;
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000010" => 
            if (wb_we_i = '1') then
              regs_o.cr_rst_unlock_load_o <= '1';
              regs_o.cr_rst_load_o <= '1';
              regs_o.cr_mpt_wr_o <= '1';
            end if;
            rddata_reg(0) <= regs_i.cr_rst_unlock_i;
            rddata_reg(1) <= regs_i.cr_rst_i;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000011" => 
            if (wb_we_i = '1') then
              regs_o.ch1ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch1ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000100" => 
            if (wb_we_i = '1') then
              regs_o.ch2ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch2ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000101" => 
            if (wb_we_i = '1') then
              regs_o.ch3ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch3ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000110" => 
            if (wb_we_i = '1') then
              regs_o.ch4ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch4ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "000111" => 
            if (wb_we_i = '1') then
              regs_o.ch5ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch5ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001000" => 
            if (wb_we_i = '1') then
              regs_o.ch6ttlpcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch6ttlpcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001001" => 
            if (wb_we_i = '1') then
              regs_o.ch1blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch1blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001010" => 
            if (wb_we_i = '1') then
              regs_o.ch2blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch2blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001011" => 
            if (wb_we_i = '1') then
              regs_o.ch3blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch3blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001100" => 
            if (wb_we_i = '1') then
              regs_o.ch4blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch4blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001101" => 
            if (wb_we_i = '1') then
              regs_o.ch5blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch5blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001110" => 
            if (wb_we_i = '1') then
              regs_o.ch6blopcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch6blopcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001111" => 
            if (wb_we_i = '1') then
              regs_o.tvlr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= regs_i.tvlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010000" => 
            if (wb_we_i = '1') then
              regs_o.tvhr_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= regs_i.tvhr_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(5 downto 0) <= regs_i.tbmr_chan_i;
            rddata_reg(31) <= regs_i.tbmr_wrtag_i;
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.tbcyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.tbtlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.tbthr_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010101" => 
            if (wb_we_i = '1') then
              regs_o.tbcsr_clr_load_o <= '1';
            end if;
            rddata_reg(6 downto 0) <= regs_i.tbcsr_usedw_i;
            rddata_reg(16) <= regs_i.tbcsr_full_i;
            rddata_reg(17) <= regs_i.tbcsr_empty_i;
            rddata_reg(18) <= regs_i.tbcsr_clr_i;
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch1ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch1ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch1ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch1ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch2ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch2ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch2ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch2ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch3ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch3ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch3ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch3ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch4ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch4ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch4ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch4ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch5ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch5ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch5ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch5ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= regs_i.ch6ltscyr_i;
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ch6ltstlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.ch6ltsthr_tai_i;
            rddata_reg(31) <= regs_i.ch6ltsthr_wrtag_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(5 downto 0) <= regs_i.lsr_front_i;
            rddata_reg(9 downto 6) <= regs_i.lsr_frontinv_i;
            rddata_reg(15 downto 10) <= regs_i.lsr_rear_i;
            rddata_reg(21 downto 16) <= regs_i.lsr_frontfs_i;
            rddata_reg(25 downto 22) <= regs_i.lsr_frontinvfs_i;
            rddata_reg(31 downto 26) <= regs_i.lsr_rearfs_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.mswr_switches_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ds18b20u_id_lsb_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ds18b20u_id_msb_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(15 downto 0) <= regs_i.ds18b20u_temp_i;
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- ID register bits
-- Gateware version
-- Status of on-board general-purpose switches
-- RTM detection lines~\cite{rtm-det}
-- I2C communication watchdog timeout error
  regs_o.sr_i2c_wdto_o <= wrdata_reg(22);
-- White Rabbit present
-- I2C communication error
  regs_o.sr_i2c_err_o <= wrdata_reg(24);
-- Pulse missed error
  regs_o.sr_pmisse_o <= wrdata_reg(30 downto 25);
-- Reset unlock bit
  regs_o.cr_rst_unlock_o <= wrdata_reg(0);
-- Reset bit - active only if RST_UNLOCK is 1
  regs_o.cr_rst_o <= wrdata_reg(1);
-- Manual Pulse Trigger
-- pass-through field: Manual Pulse Trigger in register: CR
  regs_o.cr_mpt_o <= wrdata_reg(9 downto 2);
-- TTL pulse counter value
  regs_o.ch1ttlpcr_o <= wrdata_reg(31 downto 0);
-- TTL pulse counter value
  regs_o.ch2ttlpcr_o <= wrdata_reg(31 downto 0);
-- TTL pulse counter value
  regs_o.ch3ttlpcr_o <= wrdata_reg(31 downto 0);
-- TTL pulse counter value
  regs_o.ch4ttlpcr_o <= wrdata_reg(31 downto 0);
-- TTL pulse counter value
  regs_o.ch5ttlpcr_o <= wrdata_reg(31 downto 0);
-- TTL pulse counter value
  regs_o.ch6ttlpcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch1blopcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch2blopcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch3blopcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch4blopcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch5blopcr_o <= wrdata_reg(31 downto 0);
-- BLO pulse counter value
  regs_o.ch6blopcr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 31..0
  regs_o.tvlr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 39..32
  regs_o.tvhr_o <= wrdata_reg(7 downto 0);
-- Channel mask
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- Buffer counter
-- Buffer full
-- Buffer empty
-- Clear tag buffer
  regs_o.tbcsr_clr_o <= wrdata_reg(18);
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Cycles counter
-- Lower part of TAI seconds counter
-- Upper part of TAI seconds counter
-- White Rabbit present
-- Front panel channel input state
-- Front panel INV-TTL input state
-- Rear panel input state
-- Front panel input failsafe state
-- Front panel inverter input failsafe state
-- Rear panel input failsafe state
-- Switch state
-- LS bits of 1-wire DS18B20U thermometer ID
-- MS bits of 1-wire DS18B20U thermometer ID
-- Temperature from DS18B20 thermometer
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
